// ~~ Generated by Modular Boilerplate ~~
import { default as renderToString } from 'preact-render-to-string';
import { App } from './App';
import { LocaleEnum } from './types/locale';
import { ThemeEnum } from './types/theme';
import { AppAttributeProps } from './types';

const styles = Object.fromEntries(
  Object.values(ThemeEnum).map(theme => {
    return [theme, import(`./styles/main-${theme}.scss`)];
  })
);

export const generatePrerenderHtml = ({
  locale = LocaleEnum.EN,
  market,
  theme,
  ...attrs
}: AppAttributeProps) =>
  renderToString(
    <>
      <style>{`${styles[theme]}`}</style>
      <App
        locale={locale}
        market={market}
        theme={theme}
        {...attrs}
      />
    </>,
    {
      locale,
      market,
      theme,
      ...attrs,
    },
    { pretty: true }
  );
